<?php
// $Id: leaguesite_match.admin.inc,v 1.2 2010/01/24 23:54:23 alun Exp $


function leaguesite_match_admin(){
	//add a filter table here?

	//Here, I should add all the matches which can be edited by the current user. I would like to do this on a filter table though.
	$form = array();
	//set up form where we can change various match settings
	//get all the matches that have passed the fixture date with no score. TODO: Get it to only get past matches - look up TIMESTAMP function in SQL
	$result = db_query("SELECT {leaguesite_match}.nid, {leaguesite_match}.home_team, {leaguesite_match}.away_team, {leaguesite_match}.match_time, {node}.title FROM {leaguesite_match, node} WHERE {leaguesite_match}.home_score = '' AND {leaguesite_match}.away_score = '' AND {node}.nid = {leaguesite_match}.nid AND {leaguesite_match}.match_time < UNIX_TIMESTAMP() ORDER BY {leaguesite_match}.match_time;");
	//loop through the matches and check permissions to edit the matches. If so, add them to the form.
	/*
	* Check permissions using node_access('amend', node_load($nid , $revision = NULL, $reset = NULL)))
	*/
	//add a count to see how many matches we have added.
	$count = 0;
	while($match = db_fetch_array($result)){
		if(node_access('update', node_load($match['nid']))){
			$form[$count] = array(
  		  '#type' => 'fieldset',
  		  '#title' => t($match['title']),
			);
			$form[$count][$count] = array(
        '#type' => 'hidden',
        '#value' => $match['title'],
			);
			//TODO: Check setting for 24hr time here. Definitely need DateAPI integration here
			$form[$count]['match_time'.$count] = array(
        '#type' => 'hidden',
        '#value' => date('H:i', $match['match_time']),
			);
			$form[$count]['match_id'.$count] = array(
        '#type' => 'hidden',
        '#value' => $match['nid'],
			);
			$form[$count]['home'.$count] = array(
        '#type' => 'textfield',
        '#size' => 4,
        '#required' => FALSE,
			);
			$form[$count]['away'.$count] = array(
        '#type' => 'textfield',
        '#size' => 4,
        '#required' => FALSE,
			);
			++$count;
		}
	}
	if($count > 0){
		$form['submit'] = array(
      '#type' => 'submit', '#value' => t('Save Changes'), '#weight' => 10,
		);
	}
	return $form;
}

function leaguesite_match_admin_validate($form, $form_state){

	for($id = 0; isset($form_state['values']['match_id'.$id]); ++$id){
		if(($form_state['values']['home'.$id] != '' && $form_state['values']['away'.$id] == '')||($form_state['values']['home'.$id] == '' && $form_state['values']['away'.$id] != '')){
			//return error - both teams must have scores if any have scores.
			form_set_error('home'.$id, t('Both teams must have a score entered if any have a score entered.'));
		}
	}
}

function leaguesite_match_admin_submit($form, $form_state){
	//TODO: Sort out function when result is added
	for($id = 0; isset($form_state['values']['match_id'.$id]); ++$id){
		//set results
		if($form_state['values']['home'.$id] != ''){
			$result = db_fetch_array(db_query('SELECT home_team, away_team, relation_id FROM {leaguesite_match} WHERE nid = %d;', $form_state['values']['match_id'.$id]));
			//print '_leaguesite_match_update_table('.$result['home_team'].', '.$result['away_team'].', '.$form_state['values']['home'.$id].', '.$form_state['values']['away'.$id].', '.$result['relation_id'].')';
			//die();
			//TODO: This is broken
			_leaguesite_match_update_table($result['home_team'], $result['away_team'], $form_state['values']['home'.$id], $form_state['values']['away'.$id], $result['relation_id']);
			db_query('UPDATE leaguesite_match SET home_score = %d, away_score = %d WHERE nid = %d;', $form_state['values']['home'.$id], $form_state['values']['away'.$id], $form_state['values']['match_id'.$id]);
			drupal_set_message($form_state['values'][$id].t(' result entered.'));
		}
	}
}

function leaguesite_match_settings(){
	$form = array();
	//set up form where we can change various match settings

	//update league tables when a user enters a match result
	$form['update_table_insert'] = array(
    '#type' => 'checkbox',
    '#title' => t('Update league tables when match result is entered'),
    '#description' => t('If this is checked, when a user enters a match result, the corresponding league table will be updated'),
	  '#default_value' => variable_get('leaguesite_match_update_table_insert', ''),
	);
	//update league tables when a user changes a match result
	$form['update_table_update'] = array(
    '#type' => 'checkbox',
    '#title' => t('Update league table when match result is amended'),
    '#default_value' => variable_get('leaguesite_match_update_table_update', ''),
	);
	//update league tables when a user deletes a match result
	$form['update_table_delete'] = array(
    '#type' => 'checkbox',
    '#title' => t('Update league table when match result is deleted'),
    '#default_value' => variable_get('leaguesite_match_update_table_delete', ''),
	);

	//change match teams once a match is created
	$form['change_teams'] = array(
    '#type' => 'checkbox',
    '#title' => t('Change teams'),
    '#description' => t('Allow a user to change the teams, and the league & season for a match once it has been created.'),
    '#default_value' => variable_get('leaguesite_match_change_teams', ''),
	);

	for($count = 0; $count < 24; ++$count){
		$hours[$count] = sprintf("%02d",$count); ;
	}
	for($count = 0; $count < 60; $count=$count+15){
		$mins[$count] = sprintf("%02d",$count);
	}
	$form['default_start'] = array(
    '#type' => 'fieldset',
    '#title' => t('The default start time for a match'),
	);
	$form['default_start']['hour'] = array(
    '#type' => 'select',
    '#title' => 'hour',
    '#required' => TRUE,
    '#options' => $hours,
    '#default_value' => variable_get('leaguesite_match_start_time_hour', '')
	);
	$form['default_start']['minute'] = array(
    '#type' => 'select',
    '#title' => 'minute',
    '#required' => TRUE,
    '#options' => $mins,
    '#default_value' => variable_get('leaguesite_match_start_time_minute', '')
	);

	//change match dates once a match is created (create a new node, set the original to postponed?)

	$form['submit'] = array(
    '#type' => 'submit', '#value' => t('Save')
	);
	return $form;
}

function leaguesite_match_settings_submit($form, $form_state){
	variable_set('leaguesite_match_update_table_insert', $form_state['values']['update_table_insert']);
	variable_set('leaguesite_match_update_table_update', $form_state['values']['update_table_update']);
	variable_set('leaguesite_match_update_table_delete', $form_state['values']['update_table_delete']);
	variable_set('leaguesite_match_change_teams', $form_state['values']['change_teams']);
	variable_set('leaguesite_match_start_time_hour', $form_state['values']['hour']);
	variable_set('leaguesite_match_start_time_minute', $form_state['values']['minute']);
}

/*
 * Theme for the match_admin panel, showing the upcoming games in rows
 */
function theme_leaguesite_match_admin($form){
	$output = array();
	if(isset($form['submit'])){
		$matches = array();
		foreach($form as $name => $element){
			if(isset($element['match_id'.$name]) && is_array($element['match_id'.$name])){
				//TODO: Add time and date to the match display
				$matches[] = array(
				check_plain($element['match_time'.$name]['#value']),
				check_plain($element[$name]['#value']),
				drupal_render($element['home'.$name]),
				drupal_render($element['away'.$name]),
				);
				unset($form[$name]);
			}
		}
		$teamsheader = array(t('Time'), t('Match'), t('Home Score'), t('Away Score'));
		if(count($matches) > 0){
			$output = theme('table', $teamsheader, $matches);
		}else{
			//no teams found
			$output = '';
		}
		$output .= drupal_render($form);
	}else{
		$output = t('You have no outstanding matches!');
	}
	return $output;
}